(*---------------------------------------------------------------------------
    :Program.    ShowIFF.mod
    :Author.     Fridtjof Siebert
    :Address.    Nobileweg 67, D-7-Stgt-40
    :Shortcut.   [fbs]
    :Version.    1.8
    :Date.       02-Nov-92
    :Copyright.  PD
    :Language.   Oberon
    :Translator. Amiga Oberon 3.0
    :Imports.    IFFSupport [fbs].
    :Contents.   IFF-Ladeprogramm zum Betrachten von IFF (ILBM)-Bildern.
    :Remark.     Aufruf: ShowIFF <filename>
---------------------------------------------------------------------------*)
MODULE ShowIFF;

IMPORT arg: Arguments,
       I:   Intuition,
       IFF: IFFSupport,
       d:   Dos;

VAR
  MyScreen   : I.ScreenPtr;
  WindowDummy: I.WindowPtr;
  Name       : ARRAY 80 OF CHAR;
  length     : INTEGER;
  Ciapra [0BFE001H]: SHORTSET;

BEGIN

  IF arg.NumArgs()#1 THEN

    HALT(20);

  ELSE

    arg.GetArg(1,Name);

    IF IFF.ReadILBM(Name,{IFF.front,IFF.visible},MyScreen,WindowDummy) THEN

      WHILE 6 IN Ciapra DO d.Delay(3) END;

      I.OldCloseScreen(MyScreen);

    ELSE

      I.DisplayBeep(NIL);

    END;

  END;

END ShowIFF.

